#include <stdio.h>

#define FAST_CRC16
//#define SLOW_CRC16

extern unsigned short __checksum;
extern unsigned int _FLASH16MID_BEGIN;
extern unsigned int _FLASH16MID_END;
extern unsigned int _FLASH16HI_BEGIN;
extern unsigned int _FLASH16HI_END;

extern unsigned short slow_crc16(unsigned short,unsigned char *,unsigned short);
extern unsigned short fast_crc16(unsigned short,unsigned char *,unsigned short);

const int zero=0;
void main(void)
{
     unsigned short sum=0;

#ifdef SLOW_CRC16
     sum = slow_crc16(sum,(unsigned char *)&_FLASH16MID_BEGIN, (unsigned int)&_FLASH16MID_END -2 -(unsigned int)&_FLASH16MID_BEGIN +1);
     sum = slow_crc16(sum,(unsigned char *)&_FLASH16HI_BEGIN, (unsigned int)&_FLASH16HI_END -(unsigned int)&_FLASH16HI_BEGIN +1);
     sum = slow_crc16(sum,(unsigned char *)&zero, 2);
#elif defined FAST_CRC16
     sum = fast_crc16(sum,(unsigned char *)&_FLASH16MID_BEGIN, (unsigned int)&_FLASH16MID_END -2 -(unsigned int)&_FLASH16MID_BEGIN +1);
     sum = fast_crc16(sum,(unsigned char *)&_FLASH16HI_BEGIN, (unsigned int)&_FLASH16HI_END -(unsigned int)&_FLASH16HI_BEGIN +1);
#endif
     if(sum!=__checksum)
          printf("Checksum failed: 0x%hX (counted) vs 0x%hX (from xlink)\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}
